/******************************************************************** 
 * A simple C extension module for Python, called "hello"; compile
 * this into a ".so" on python path, import and call hello.message;
 ********************************************************************/

#include <Python.h>
#include <string.h>

/* module functions */
static PyObject * message(PyObject *self, PyObject *args) /* returns object */
                                                  /* self unused in modules */
{                                                 /* args from python call */
    char *fromPython, result[64];
    if (! PyArg_Parse(args, "(s)", &fromPython))  /* convert Python -> C */
        return NULL;                              /* null=raise exception */
    else 
    {
      strcpy(result, "delo --- ");                /* build up C string */
      strcat(result, fromPython);                 /* add passed Python string */
      return Py_BuildValue("s", result);          /* convert C -> Python */
    }
}

/* registration table  */
static struct PyMethodDef delo_methods[] = {
    {"message", message, 1},          /* method name, C func ptr, always-tuple */
    {NULL, NULL}                      /* end of table marker */
};

/* module initializer */
void initdelo()                        /* called on first import */
{                                      /* name matters if loaded dynamically */
    (void) Py_InitModule("delo", delo_methods);   /* mod name, table ptr */
}
